/**
 ** rflexRflexTaskCodels.c
 **
 ** Codels appeles par la tache rflexRflexTask
 **
 **
 **/

#include <portLib.h>
#include "math.h"
#include <stdio.h>
#include <fcntl.h>

#include "h2mathLib.h"

#include "rflexConst.h"
#include "server/rflexHeader.h"


/* rajouter la struct reflex */
#include "rFlex.h"
#include "rflexClient.h"
#include "odo.h"
#include "rflexSonars.h"

static int sonarsInit=FALSE;
static double cosTheta[RFLEX_NMAX_SENSORS];
static double sinTheta[RFLEX_NMAX_SENSORS];

/*----------------------------------------------------------------------*/
static STATUS
rflexComputeSensorsCoord()
{
  int i;

  /* pre-calcul des sinus et cosinus des anches des capteurs */
  for (i = 0; i < RFLEX_NMAX_SENSORS; i++) {

    cosTheta[i] = cos(SDI_F->sonarsConfig.tab[i].theta);
    sinTheta[i] = sin(SDI_F->sonarsConfig.tab[i].theta);

  } /* for */
  sonarsInit=TRUE;
  return OK;
}


/*----------------------------------------------------------------------*/
STATUS
rFlexComputeSensorsEchoes(int *bilan)
{
  int i;
  RFLEX_POINT *robotTab;
  double measure;

  if (sonarsInit != TRUE)
    rflexComputeSensorsCoord();

  /* Copie Us */
  robotTab = &(SDI_F->measureInRobotCart.tab[0]);

  /* Pour chaque US */
  for (i = 0; i < RFLEX_NMAX_SENSORS; i++) {

    measure = SDI_F->sonarRange.tab[i];

    /* Calcul des echos dans le repere local */
    robotTab[i].x = SDI_F->sonarsConfig.tab[i].x + measure*cosTheta[i];
    robotTab[i].y = SDI_F->sonarsConfig.tab[i].y + measure*sinTheta[i];

  } /* for */

  return OK;
}

